## r-cran-listenv 0.6.0

=== DESCRIPTION ===
Package: listenv
Version: 0.6.0
Depends: R (>= 3.1.2)
Suggests: R.utils, R.rsp
VignetteBuilder: R.rsp
Title: Environments Behaving (Almost) as Lists
Authors@R: c(person("Henrik", "Bengtsson", role=c("aut", "cre", "cph"),
                                          email = "henrikb@braju.com"))
Description: List environments are environments that have list-like properties.  For instance, the elements of a list environment are ordered and can be accessed and iterated over using index subsetting, e.g. 'x <- listenv(a=1, b=2); for (i in seq_along(x)) x[[i]] <- x[[i]]^2; y <- as.list(x)'.
License: LGPL (>= 2.1)
LazyLoad: TRUE
URL: https://github.com/HenrikBengtsson/listenv
BugReports: https://github.com/HenrikBengtsson/listenv/issues
RoxygenNote: 5.0.1
NeedsCompilation: no
Packaged: 2015-12-27 23:02:54 UTC; hb
Author: Henrik Bengtsson [aut, cre, cph]
Maintainer: Henrik Bengtsson <henrikb@braju.com>
Repository: CRAN
Date/Publication: 2015-12-28 00:07:26
