=== debian/changelog ===
r-cran-listenv (0.6.0-1build1) artful; urgency=medium

  * No-change rebuild to pick up r-api-3.4

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 27 Sep 2017 09:29:28 +0000

r-cran-listenv (0.6.0-1) unstable; urgency=medium

  * Initial release. (Closes: #828194)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sat, 25 Jun 2016 13:58:30 -0700
