=== debian/control ===
Source: r-cran-listenv
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>
Section: gnu-r
Priority: optional
Build-Depends: debhelper (>= 9),
               cdbs,
               r-base-dev
Standards-Version: 3.9.8
Homepage: https://github.com/HenrikBengtsson/listenv
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/r-cran-listenvs.git
Vcs-Git: https://anonscm.debian.org/debian-med/r-cran-listnev.git

Package: r-cran-listenv
Architecture: any
Depends: ${R:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: R package: Environments Behaving (Almost) as Lists
 List environments are environments that have list-like properties. For
 instance, the elements of a list environment are ordered and can be accessed
 and iterated over using index subsetting, e.g. 'x <- listenv(a=1, b=2); for (i
 in seq_along(x)) x[[i]] <- x[[i]]^2; y <- as.list(x)'.
