=== debian/changelog ===
r-cran-listenv (0.7.0-2) unstable; urgency=medium

  * Team upload.
  * Maintainer: Debian R Packages Maintainers <r-pkg-team@alioth-
    lists.debian.net>
  * Point Vcs fields to salsa.debian.org
  * dh-update-R to update Build-Depends
  * Architecture: all (instead of any)

 -- Andreas Tille <tille@debian.org>  Fri, 15 Jun 2018 15:08:35 +0200

r-cran-listenv (0.7.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * cme fix dpkg-control
  * Convert from cdbs to dh-r
  * debhelper 11
  * Canonical watch file for CRAN packages
  * Canonical homepage for CRAN packages

 -- Andreas Tille <tille@debian.org>  Thu, 01 Mar 2018 23:00:17 +0100
