=== debian/control ===
Source: r-cran-listenv
Maintainer: Debian R Packages Maintainers <r-pkg-team@alioth-lists.debian.net>
Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>
Section: gnu-r
Priority: optional
Build-Depends: debhelper (>= 11~),
               dh-r,
               r-base-dev
Standards-Version: 4.1.4
Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-listenv
Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-listenv.git
Homepage: https://cran.r-project.org/package=listenv

Package: r-cran-listenv
Architecture: all
Depends: ${R:Depends},
         ${misc:Depends}
Recommends: ${R:Recommends}
Suggests: ${R:Suggests}
Description: R package: Environments Behaving (Almost) as Lists
 List environments are environments that have list-like properties. For
 instance, the elements of a list environment are ordered and can be accessed
 and iterated over using index subsetting, e.g. 'x <- listenv(a=1, b=2); for (i
 in seq_along(x)) x[[i]] <- x[[i]]^2; y <- as.list(x)'.
