## r-cran-listenv 0.8.0

=== DESCRIPTION ===
--- 
+++ 
@@ -1,13 +1,8 @@
 Package: listenv
-Version: 0.7.0
-Depends:
-    R (>= 3.1.2)
-Suggests:
-    R.utils,
-    R.rsp,
-    markdown
-VignetteBuilder:
-    R.rsp
+Version: 0.8.0
+Depends: R (>= 3.1.2)
+Suggests: R.utils, R.rsp, markdown
+VignetteBuilder: R.rsp
 Title: Environments Behaving (Almost) as Lists
 Authors@R: c(person("Henrik", "Bengtsson", role=c("aut", "cre", "cph"),
                                           email = "henrikb@braju.com"))
@@ -16,5 +11,10 @@
 LazyLoad: TRUE
 URL: https://github.com/HenrikBengtsson/listenv
 BugReports: https://github.com/HenrikBengtsson/listenv/issues
-RoxygenNote: 6.0.1
-Roxygen: list(markdown = TRUE)
+RoxygenNote: 7.0.2
+NeedsCompilation: no
+Packaged: 2019-12-05 19:44:24 UTC; hb
+Author: Henrik Bengtsson [aut, cre, cph]
+Maintainer: Henrik Bengtsson <henrikb@braju.com>
+Repository: CRAN
+Date/Publication: 2019-12-05 21:40:02 UTC
