=== debian/changelog ===
r-cran-listenv (0.8.0-1) unstable; urgency=medium

  * New upstream version
  * debhelper-compat 12
  * Standards-Version: 4.4.0
  * Set upstream metadata fields: Archive, Bug-Database, Repository.

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 06 Dec 2019 13:51:41 +0100
