=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>
 Section: gnu-r
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 12),
                dh-r,
                r-base-dev
-Standards-Version: 4.1.4
+Standards-Version: 4.4.0
 Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-listenv
 Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-listenv.git
 Homepage: https://cran.r-project.org/package=listenv
