## r-cran-listenv 0.8.0+dfsg

=== debian/changelog ===
r-cran-listenv (0.8.0+dfsg-1build1) groovy; urgency=medium

  * No-change rebuild against r-api-4.0

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 30 May 2020 10:10:56 +0000
