=== debian/control ===
--- 
+++ 
@@ -6,10 +6,11 @@
 Build-Depends: debhelper-compat (= 12),
                dh-r,
                r-base-dev
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-listenv
 Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-listenv.git
 Homepage: https://cran.r-project.org/package=listenv
+Rules-Requires-Root: no
 
 Package: r-cran-listenv
 Architecture: all
