=== debian/changelog ===
r-cran-listenv (0.9.0+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Reorder sequence of d/control fields by cme (routine-update)
  * Testsuite: autopkgtest-pkg-r (routine-update)
  * Set upstream metadata fields: Contact.

 -- Andreas Tille <tille@debian.org>  Tue, 20 Dec 2022 14:40:31 +0100
