=== debian/control ===
--- 
+++ 
@@ -1,16 +1,17 @@
 Source: r-cran-listenv
+Section: gnu-r
+Testsuite: autopkgtest-pkg-r
+Priority: optional
 Maintainer: Debian R Packages Maintainers <r-pkg-team@alioth-lists.debian.net>
-Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>
-Section: gnu-r
-Priority: optional
-Build-Depends: debhelper-compat (= 12),
-               dh-r,
-               r-base-dev
-Standards-Version: 4.5.0
+Uploaders: Michael R. Crusoe <crusoe@debian.org>
 Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-listenv
 Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-listenv.git
 Homepage: https://cran.r-project.org/package=listenv
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
+Build-Depends: debhelper-compat (= 13),
+               dh-r,
+               r-base-dev
 
 Package: r-cran-listenv
 Architecture: all
