## r-cran-listenv 0.9.1+dfsg

=== debian/changelog ===
r-cran-listenv (0.9.1+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * dh-update-R to update Build-Depends (routine-update)
  * Set field Upstream-Contact in debian/copyright.
  * Remove obsolete field Contact from debian/upstream/metadata (already
    present in machine-readable debian/copyright).

 -- Andreas Tille <tille@debian.org>  Thu, 01 Feb 2024 16:53:26 +0100
