=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: r-cran-listenv
 Section: gnu-r
-Testsuite: autopkgtest-pkg-r
 Priority: optional
 Maintainer: Debian R Packages Maintainers <r-pkg-team@alioth-lists.debian.net>
 Uploaders: Michael R. Crusoe <crusoe@debian.org>
@@ -12,6 +11,7 @@
 Build-Depends: debhelper-compat (= 13),
                dh-r,
                r-base-dev
+Testsuite: autopkgtest-pkg-r
 
 Package: r-cran-listenv
 Architecture: all
