=== debian/tests/control ===
Tests: run-unit-test
Depends: @,
         r-cran-r.utils,
        r-cran-r.rsp,
        r-cran-markdown
Restrictions: allow-stderr
